VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Messages"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'local variable(s) to hold property value(s)
Private mvarLogFile As String 'local copy
Private mvarAppVersion As String 'local copy
Private mvarLogPath As String 'local copy
Private mvarMailTo As String 'local copy
Private mvarPrintHeader As String 'local copy
Private mvarSource As String 'local copy
Private mvarUserId As String 'local copy

Private mvarCounter As Long ' a Counter of messages

' A collection of messages
Private colMessages As New Collection
' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
'   Add : Adds a new message to the queue
' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
Public Function Add(Key As Variant, _
                    Optional strMsgBold As String, _
                    Optional lngMsgStyle As Long, _
                    Optional strMsgTitle As String, _
                    Optional strMsgNormal As String) _
                    As Message
                    
    ' Create a message object
    Dim cMessage As New Message
    
    ' Set up the default properties
    With cMessage
        If Not IsMissing(strMsgBold) Then
            ' Only add the BoldMessage Property if specified
            .BoldMessage = strMsgBold
        End If
        
        If Not IsMissing(strMsgNormal) Then
            ' Only add the NormalMessage Property if specified
            .NormalMessage = strMsgNormal
        End If
        
        If Not IsMissing(strMsgTitle) Then
            ' Only add the caption Property if specified
            .Caption = strMsgTitle
        End If
        
        .MsgStyle = lngMsgStyle
        
        .Source = mvarSource
        .MailTo = mvarMailTo
        .LogPath = mvarLogPath
        .LogFile = mvarLogFile
        .UserId = mvarUserId
        .PrintHeader = mvarPrintHeader
        .AppVersion = mvarAppVersion
        
    End With
    
    ' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
    ' Add the message to the collection
    ' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
    
    ' Determine if we specified an index or key
    colMessages.Add cMessage, Key
    
    
    ' Increment the number of message
    mvarCounter = mvarCounter + 1
    
    ' Set the Add = the new message
    Set Add = cMessage
    
    ' Clear the reference to the cMessage
    Set cMessage = Nothing

End Function



' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
'   Clear : Erases all messages in the system
' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
Public Sub Clear()
    colMessages.Clear
    
    mvarCounter = 0
End Sub


' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
'   Count : returns the number of messages
' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
Public Property Get Count() As Long
    Count = mvarCounter
End Property

' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
'   Item : Returns the specified message
' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
Public Function Item(Key As Variant) As Message

    On Error GoTo Item_Error
    
    Set Item = colMessages.Item(Key)
    
    Exit Function
    
Item_Error:
    RaiseError vbObjectError + 1, "Item Not Found"
    
End Function

' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
' Removes the message from the collection
' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
Public Sub Remove(Key As Variant)
    On Error Resume Next
    
    ' Decrement the counter
    mvarCounter = mvarCounter - 1
    
    ' Remove the item
    colMessages.Remove Key
    
    If Err.Number Then
        Err.Raise vbObjectError + 2, "Message", "Item does not exist"
        Err.Clear
    End If
    
    On Error GoTo 0
End Sub


Public Property Let UserId(ByVal vData As String)
Attribute UserId.VB_Description = "Returns/Sets the UserId"
    On Error GoTo UserIdLetErr

'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.UserId = 5
    mvarUserId = vData
    Exit Property

UserIdLetErr:
    Call RaiseError(MyUnhandledError, "Messages:UserId Property Let")
End Property
Public Property Get UserId() As String
    On Error GoTo UserIdGetErr

'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.UserId
    UserId = mvarUserId
    Exit Property

UserIdGetErr:
    Call RaiseError(MyUnhandledError, "Messages:UserId Property Get")

End Property

Public Property Let Source(ByVal vData As String)
Attribute Source.VB_Description = "Returns/Sets the source of the error"
    On Error GoTo SourceLetErr

'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Source = 5
    mvarSource = vData
    Exit Property

SourceLetErr:

    Call RaiseError(MyUnhandledError, "Messages:Source Property Let")
End Property

Public Property Get Source() As String
    On Error GoTo SourceGetErr

'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Source
    Source = mvarSource
    Exit Property

SourceGetErr:

    Call RaiseError(MyUnhandledError, "Messages:Source Property Get")
End Property

Public Property Let PrintHeader(ByVal vData As String)
    On Error GoTo PrintHeaderLetErr

'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.PrintHeader = 5
    mvarPrintHeader = vData
    Exit Property

PrintHeaderLetErr:

    Call RaiseError(MyUnhandledError, "Messages:PrintHeader Property Let")
End Property

Public Property Get PrintHeader() As String
    On Error GoTo PrintHeaderGetErr

'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.PrintHeader
    PrintHeader = mvarPrintHeader
    Exit Property

PrintHeaderGetErr:

    Call RaiseError(MyUnhandledError, "Messages:PrintHeader Property Get")
End Property

Public Property Let MailTo(ByVal vData As String)
Attribute MailTo.VB_Description = "Returns/Sets the User(s) to send the email to"
    On Error GoTo MailToLetErr

'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.MailTo = 5
    mvarMailTo = vData
    Exit Property

MailToLetErr:

    Call RaiseError(MyUnhandledError, "Messages:MailTo Property Let")
End Property

Public Property Get MailTo() As String
    On Error GoTo MailToGetErr

'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.MailTo
    MailTo = mvarMailTo
    Exit Property

MailToGetErr:

    Call RaiseError(MyUnhandledError, "Messages:MailTo Property Get")
End Property

Public Property Let LogPath(ByVal vData As String)
Attribute LogPath.VB_Description = "Returns/Sets the path that the error log file will reside"
    On Error GoTo LogPathLetErr

'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.LogPath = 5
    mvarLogPath = vData
    Exit Property

LogPathLetErr:
    
    Call RaiseError(MyUnhandledError, "Messages:LogPath Property Let")
End Property


Public Property Get LogPath() As String
    On Error GoTo LogPathGetErr


'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.LogPath
    LogPath = mvarLogPath
    Exit Property


LogPathGetErr:


    Call RaiseError(MyUnhandledError, "Messages:LogPath Property Get")
End Property



Public Property Let AppVersion(ByVal vData As String)
Attribute AppVersion.VB_Description = "Returns/Sets the Application version"
    On Error GoTo AppVersionLetErr


'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.AppVersion = 5
    mvarAppVersion = vData
    Exit Property


AppVersionLetErr:


    Call RaiseError(MyUnhandledError, "Messages:AppVersion Property Let")
End Property


Public Property Get AppVersion() As String
    On Error GoTo AppVersionGetErr


'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.AppVersion
    AppVersion = mvarAppVersion
    Exit Property


AppVersionGetErr:


    Call RaiseError(MyUnhandledError, "Messages:AppVersion Property Get")
End Property



Public Property Let LogFile(ByVal vData As String)
Attribute LogFile.VB_Description = "Returns/Sets the Log File name"
    On Error GoTo LogFileLetErr


'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.LogFile = 5
    mvarLogFile = vData
    Exit Property


LogFileLetErr:


    Call RaiseError(MyUnhandledError, "Messages:LogFile Property Let")
End Property


Public Property Get LogFile() As String
    On Error GoTo LogFileGetErr

    'used when retrieving value of a property, on the right side of an assignment.
    'Syntax: Debug.Print X.LogFile
    LogFile = mvarLogFile
    Exit Property

LogFileGetErr:
    Call RaiseError(MyUnhandledError, "Messages:LogFile Property Get")
End Property

