Attribute VB_Name = "modError"
Option Explicit

' Dim the Messages Object
Public gobjMessages As Messages

' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
'   ErrorHandler: All errors should come here
'       Parameters:
'            strProcedureName : the calling Procedure
'
' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
Public Sub ErrorHandler(strProcedureName As String, _
                        objErr As ErrObject, _
                        Optional strProgNotes As String, _
                        Optional strSQl As String)
    
    Dim objErrorMessage     As Message
    
    Set objErrorMessage = gobjMessages.Add(strProcedureName)
    
    ' Yeild to the system
    DoEvents
    
    ' Set up our local information
    With objErrorMessage
        .BoldMessage = "System Runtime Error"   ' Best if keep in a RC file
        .NormalMessage = objErr.Description
        .Number = objErr.Number
        .Description = objErr.Description
        .Location = strProcedureName
        .Source = App.ProductName
        .Comments = ""
        .ProgrammerNote = strProgNotes
        .SQLStatement = strSQl
        .DetailsButton = True
        .MsgStyle = vbCritical
        .Show
        
    End With
    
    
    ' Remove the Message from the Messages collection
    gobjMessages.Remove strProcedureName
    
ErrorHandler_Exit:
    On Error GoTo 0
    Exit Sub
    
ErrorHandler_Error:
    ' We have to report the error via a message box because
    ' the Error Handler Failed
    
    MsgBox "An error was found!" & vbCrLf & "It was found at " & _
        strProcedureName & vbCrLf & _
        "The error was #" & Trim$(Str$(objErr.Number)) & "-" & _
        objErr.Description, vbCritical, App.ProductName
End Sub



' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
'   InitializeMessageLibrary : Sets up the default parameters
'       for each message
' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
Public Function InitializeMessageLibrary()

    #If InDevelopment = False Then
        On Error GoTo InitializeMessageLibrary_Error
    #End If
    
    ' Declare the Location, for debugging
    Const sProcName As String = "modError_InitializeMessageLibrary"
    
    ' Create the Object
    Set gobjMessages = New Messages
    
    ' Initialize the common properties for the message library
    With gobjMessages
        .Source = App.ProductName
        .LogFile = "LogFile.Text"
        .LogPath = "C:\My Documents"
        .UserId = "GSAPMT"
        .MailTo = "Guardagno, Joseph (Exchange)"
        .Printheader = "Please Fax to " & vbCrLf
        .Printheader = .Printheader & "Bear Stearns" & vbCrLf
        .Printheader = .Printheader & "1-212-2728896" & vbCrLf
        .Printheader = .Printheader & "Attn: Joseph Guadagno"
        .AppVersion = App.Major & "." & App.Minor & "." & App.Revision
    End With

'   Common Exit point
InitializeMessageLibrary_Exit:
    On Error GoTo 0     ' Reset the error handling, just in case
    Exit Function       ' Leave the sub/function
    
'   Error handling
InitializeMessageLibrary_Error:
    ' We have to report the error via a message box because
    ' the Error Handler has not been created yet
    MsgBox "An error was found!" & vbCrLf & "It was found at " & _
        sProcName & vbCrLf & _
        "The error was #" & Trim$(Str$(Err.Number)) & "-" & _
        Err.Description, vbCritical, App.ProductName
End Function

